/*
	VO France Tutoriel
 */
package cds.tuto;

import java.util.*;
import java.io.*;

import cds.savot.common.*;
import cds.savot.model.*;
import cds.savot.writer.*;
import cds.savot.pull.*;

import UCD_pkg.*;

/** Traduction des UCD1 en UCD1+
 * On ne traite que la premire table de la premire RESOURCE
 * @author T .Boch - S. Derriere
 */
public class Converter {
	
	public Converter() {}

	
	/** Lit le VOTable dans le flux in, traduit les UCD1 en UCD1+, 
	 * puis rcrit le VOTable produit dans le flux out
	 * 
	 * @param in
	 * @param out
	 */
	public void performConvert(InputStream in, OutputStream out) {
		// Le fichier VOTable est entirement charg en mmoire
		SavotPullParser parser = new SavotPullParser(in, SavotPullEngine.FULL, null);

		// on rcupre l'objet VOTable
		SavotVOTable vot = parser.getVOTable();
		
		SavotResource firstRes = (SavotResource)(vot.getResources().getItemAt(0));
		FieldSet fset = firstRes.getFieldSet(0);
		
                // locator creation
                UCDService locator = new UCDServiceLocator();
                // UCD object
                UCD mya = null;
                try {
		// A COMPLETER
                        //mya = locator.getUCD();
                }
                catch (Exception e ) {
                        System.out.println("UCD XML WS client : " + e);
                        return;
                }

		// on parcourt les champs pour remplacer l'attribut 'ucd'
		Enumeration e = fset.getItems().elements();
		String oldUCD;
		String newUCD;

		while( e.hasMoreElements() ) {
			SavotField curField = (SavotField)e.nextElement();
			// A COMPLETER on lit la valeur actuelle de l'UCD
			oldUCD=curField.getUcd();
			try {
			// A COMPLETER on fait un appel au WS translate
			// le trim() enleve juste le \n final du resultat 
				curField.setUcd(newUCD=mya.translate(oldUCD).trim());
			}
			catch (Exception ex ) {System.out.println("UCD XML WS client : " + ex);}
		}		
		
		// criture de l'objet VOTable (modifi) dans le flux de sortie
		new WriteDocument().generateDocument(vot, out);



	}

	/** Gestion des entrees-sorties
	 */
	public static void main(String[] args) {
		if( args.length==0 ) {
			System.out.println("Error : please enter the name of the VOTable file");
			return;
		}

		try {
			OutputStream out;
			if( args.length>1 ) out = new FileOutputStream(args[1]);
			else out = System.out;

			InputStream in = new FileInputStream(args[0]);

			new Converter().performConvert(in, out);
		} catch( FileNotFoundException e ) {
			System.out.println("File not found !!");
			e.printStackTrace();
		}

	}
}

