#!/usr/bin/perl -I /local/share/perl/5.8.2

use SOAP::Lite;
use LWP::Protocol::http;
use strict;

my $descriptionFile = "./descriptions.dat";
my $service = SOAP::Lite->service("http://cdsws.u-strasbg.fr/axis/services/UCD?wsdl");

my $description;
my $result;
local *FF;
open (FF, $descriptionFile) || die "*** Error opening file!";
while (<FF>)
{
	# we read one description in the file
	$description = $_;
	chop($description);
	
	# we call the Web Service to assign the UCD
	eval { $result = $service->assign("$description"); };

	if ( $@ ) { # Check for errors
		my $status = $service->transport()->status();
		print "Transport Status: " . $status . "\n";
		print "Error: $@";
		exit;
	}
	# and we print the result
	print "$description | $result";
}
close (FF);

